queryByCondition
===
* 根据不为空的参数进行分页查询

    select 
    \@pageTag(){
    t.*
    \@}
    from ${entity.tableName} t
    where 1=1  
    \@//数据权限，该sql语句功能点,如果不考虑数据权限，可以删除此行  
    and #function("${entity.code}.query")#
    @for(attr in entity.list){
            @if(attr.showInQuery){
                @if(attr.dateRange || attr.dateTimeRange){
    \@if(!isEmpty(${strutil.replace (attr.name,"Range","")}Start)){
        and t.${attr.colName} > #${strutil.replace (attr.name,"Range","")}Start#
    \@}
    \@if(!isEmpty(${strutil.replace (attr.name,"Range","")}End)){
        and t.${attr.colName} < #${strutil.replace (attr.name,"Range","")}End#
    \@}
                @} else {
    \@if(!isEmpty(${attr.name})){
        and t.${attr.colName} =#${attr.name}#
    \@}
                @}
            @}
    @}
    
    

delete${entity.name}ByIds
===

* 批量删除

    delete from ${entity.tableName} where find_in_set(${entity.idAttribute.colName},#ids#)

    
get${entity.name}Values
===

* 根据不为空的参数进行查询

    select t.*
    from ${entity.tableName} t
    where 1=1  
    @for(attr in entity.list){
                @if(attr.dateRange || attr.dateTimeRange){
    \@if(!isEmpty(${strutil.replace (attr.name,"Range","")}Start)){
        and t.${attr.colName} > #${strutil.replace (attr.name,"Range","")}Start#
    \@}
    \@if(!isEmpty(${strutil.replace (attr.name,"Range","")}End)){
        and t.${attr.colName} < #${strutil.replace (attr.name,"Range","")}End#
    \@}
                @} else {
    \@if(!isEmpty(${attr.name})){
        and t.${attr.colName} =#${attr.name}#
    \@}
                @}
    @}
   
    
getValuesByQuery
===

* 根据不为空的参数进行查询

    select t.*
    from ${entity.tableName} t
    where 1=1  
    @for(attr in entity.list){
                @if(attr.dateRange || attr.dateTimeRange){
    \@if(!isEmpty(${strutil.replace (attr.name,"Range","")}Start)){
        and t.${attr.colName} > #${strutil.replace (attr.name,"Range","")}Start#
    \@}
    \@if(!isEmpty(${strutil.replace (attr.name,"Range","")}End)){
        and t.${attr.colName} < #${strutil.replace (attr.name,"Range","")}End#
    \@}
                @} else {
    \@if(!isEmpty(${attr.name})){
        and t.${attr.colName} =#${attr.name}#
    \@}
                @}
    @}