package ${package};

import java.util.List;
import java.util.Map;

import ${basePackage}.dao.${entity.name}Dao;
import ${basePackage}.entity.${entity.name};
import ${basePackage}.web.query.${entity.name}Query;

import com.ibeetl.admin.core.service.CoreBaseService;
import com.ibeetl.admin.core.util.PlatformException;
import org.beetl.sql.core.engine.PageQuery;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;


/**
 * ${entity.displayName} Service
 */

\@Service
\@Transactional
public class ${entity.name}Service extends CoreBaseService<${entity.name}>{

        \@Autowired private ${entity.name}Dao ${entity.code}Dao;

public PageQuery<${entity.name}>queryByCondition(PageQuery query){
        PageQuery ret =  ${entity.code}Dao.queryByCondition(query);
        queryListAfter(ret.getList());
        return ret;
        }

public void delete${entity.name}(String ids){
        try {
        ${entity.code}Dao.delete${entity.name}ByIds(ids);
        } catch (Exception e) {
        throw new PlatformException("批量删除${entity.displayName}失败", e);
        }
        }

public List<${entity.name}> getValues (Object paras){
        return sqlManager.select("jlw.${entity.code}.get${entity.name}Values",${entity.name}.class,paras);
        }

public List<${entity.name}> getValuesByQuery (${entity.name}Query ${entity.code}Query){
        return ${entity.code}Dao.getValuesByQuery(${entity.code}Query);
        }
        }