/**
 * 用于点击.rightmenu之外的地方关闭.rightmenu选项框（右键菜单）
 */
$(document).click(function(e){
    var target = $(e.target);
    if(target.closest(".rightmenu").length == 0){//点击class==rightmenu之外的地方触发
        $('.rightmenu').hide(); //隐藏右键菜单
        $(".rightmenu", window.parent.document).hide();//关闭父级
        $(".rightmenu", window.parent.parent.document).hide();//关闭父级的父级 如果还存在 继续类推下去
    }
});
var Lib = {
    tablePage: {
        //"layout" : [ 'count', 'prev', 'page', 'next']
        "prev": "上一页",
        "next": "下一页",
        "limits": [10, 30, 50, 100],
        "layout": ['count', 'prev', 'next', 'page', 'limit', 'refresh', 'skip']
    },
    loadOrgPanel: function (container, textInput, valueInput) {
        $.post(Common.ctxPath + "/core/user/org.json", {}, function (response) {
            var zNodes = response.data;
            var zTreeObj = null;
            var index = layer.open({
                type: 0,
                area: ['500px', '400px'],
                offset: 't',
                shadeClose: true,
                anim: 5,
                title: '选择组织机构',
                content: "<ul id='_treeDemo' class='ztree'></ul>",
                btn: ['确定', '重置'],
                success: function (layero, index) {
                    zTreeObj = $.fn.zTree.init($("#_treeDemo"), {}, zNodes);
                    if (valueInput.val()) {
                        var node = zTreeObj.getNodeByParam("id", valueInput.val());
                        zTreeObj.selectNode(node, true);
                        zTreeObj.expandNode(node, true, false);
                    }
                },
                yes: function (index, layero) {
                    var nodes = zTreeObj.getSelectedNodes();

                    if (nodes.length == 1) {
                        var org = nodes[0];
                        valueInput.val(org.id);
                        textInput.val(org.name);
                    }
                    layer.close(index);
                },
                btn2: function (index, layero) {
                    valueInput.val('');
                    textInput.val('');
                    zTreeObj.cancelSelectedNode();
                }

            });

        })
    },
    loadFunPanel: function (container, textInput, valueInput) {
        $.post(Common.ctxPath + "/core/user/function/tree.json", {}, function (response) {
            var zNodes = response.data;
            var zTreeObj = null;
            var index = layer.open({
                type: 0,
                area: ['500px', '400px'],
                offset: 't',
                anim: 5,
                title: '选择功能点',
                content: "<ul id='_treeDemo' class='ztree'></ul>",
                btn: ['确定', '重置'],
                success: function (layero, index) {
                    zTreeObj = $.fn.zTree.init($("#_treeDemo"), {}, zNodes);
                    if (valueInput.val()) {
                        var node = zTreeObj.getNodeByParam("id", valueInput.val());
                        zTreeObj.selectNode(node, true);
                        zTreeObj.expandNode(node, true, false);
                    }
                },
                yes: function (index, layero) {
                    var nodes = zTreeObj.getSelectedNodes();

                    if (nodes.length == 1) {
                        var fun = nodes[0];
                        valueInput.val(fun.id);
                        textInput.val(fun.name);
                    }
                    layer.close(index);
                },
                btn2: function (index, layero) {
                    valueInput.val('');
                    textInput.val('');
                    zTreeObj.cancelSelectedNode();
                }
            });

        })
    },
    loadMenuPanel: function (container, textInput, valueInput) {
        $.post(Common.ctxPath + "/core/user/menu/tree.json", {}, function (response) {
            var zNodes = response.data;
            var zTreeObj = null;
            var index = layer.open({
                type: 0,
                area: ['500px', '400px'],
                offset: 't',
                anim: 5,
                title: '选择菜单',
                content: "<ul id='_treeDemo' class='ztree'></ul>",
                btn: ['确定', '重置'],
                success: function (layero, index) {
                    zTreeObj = $.fn.zTree.init($("#_treeDemo"), {}, zNodes);
                    if (valueInput.val()) {
                        var node = zTreeObj.getNodeByParam("id", valueInput.val());
                        zTreeObj.selectNode(node, true);
                        zTreeObj.expandNode(node, true, false);
                    }
                },
                yes: function (index, layero) {
                    var nodes = zTreeObj.getSelectedNodes();

                    if (nodes.length == 1) {
                        var fun = nodes[0];
                        valueInput.val(fun.id);
                        textInput.val(fun.name);
                    }
                    layer.close(index);
                },
                btn2: function (index, layero) {
                    valueInput.val('');
                    textInput.val('');
                    zTreeObj.cancelSelectedNode();
                }
            });

        })
    },
    loadMenuFunPanel: function (container, textInput, valueInput) {
        $.post(Common.ctxPath + "/core/user/function/tree.json", {}, function (response) {
            var zNodes = response.data;
            var zTreeObj = null;
            var index = layer.open({
                type: 0,
                area: ['500px', '400px'],
                offset: 't',
                anim: 5,
                title: '选择功能点',
                content: "<ul id='_treeDemo' class='ztree'></ul>",
                btn: ['确定', '重置'],
                success: function (layero, index) {
                    zTreeObj = $.fn.zTree.init($("#_treeDemo"), {}, zNodes);
                    if (valueInput.val()) {
                        var node = zTreeObj.getNodeByParam("id", valueInput.val());
                        zTreeObj.selectNode(node, true);
                        zTreeObj.expandNode(node, true, false);
                    }
                },
                yes: function (index, layero) {
                    var nodes = zTreeObj.getSelectedNodes();

                    if (nodes.length == 1) {
                        var fun = nodes[0];
                        valueInput.val(fun.id);
                        textInput.val(fun.name + '：' + fun.accessUrl);
                    }
                    layer.close(index);
                },
                btn2: function (index, layero) {
                    valueInput.val('');
                    textInput.val('');
                    zTreeObj.cancelSelectedNode();
                }
            });
        })
    },
    /* 初始化搜索 */
    initSearchForm: function (form, tableIns, layuiForm) {
        id = form.attr("id");
        Lib.initGenrealForm(form, layuiForm);
        var btn = $("#" + id + "Search");
        btn.on('click', function () {
            Lib.doSearchForm(form, tableIns, 1);
        });
    },
    /* form 种各个事件的处理 */
    initGenrealForm: function (form, layuiForm) {
        layuiForm.on('select', function (data) {
            var dom = data.elem;
            var groupName = $(dom).data("group");
            if (!$.isEmpty(groupName)) {
                Lib._dropdown(layuiForm, data, form, dom, groupName);
                return;
            }
        });

        $(form).find(".date-range-pick").find("input").each(function () {
            laydate = layui.laydate;
            laydate.render({
                elem: $(this)[0],
                range: '至'
            });
        });

        $(form).find(".datetime-range-pick").find("input").each(function () {
            laydate = layui.laydate;
            laydate.render({
                elem: $(this)[0],
                range: '至',
                type: 'datetime'
            });
        });


        $(form).find(".input-date").each(function () {
            laydate = layui.laydate;
            laydate.render({
                elem: $(this)[0],
            });
        })


    },
    _dropdown: function (layuiForm, data, form, select, groupName) {
        var selects = $(form).find("select[data-group='" + groupName + "']");
        var start = 0;
        for (var i = 0; i < selects.length; i++) {
            if ($(select).is(selects[i])) {
                start = i + 1;
                break;
            }
        }
        if (start == selects.length) {
            //最后一个级联，不处理
            return;
        }
        value = data.value;
        if (value != "") {
            Common.post("/core/dict/viewChildren.json", {
                "value": value,
                "group": groupName
            }, function (serverData) {
                Lib._resetDictSelect(selects[start], serverData);
                layuiForm.render();

            })
        } else {
            for (var j = 0, i = start; i < selects.length; i++, j++) {
                Lib._resetDictSelect(selects[start], [])
            }
            layuiForm.render();
        }

    },

    _resetDictSelect: function (select, list) {
        $(select).empty();
        $(select).append("<option value=''>请选择</option>");
        for (var i = 0; i < list.length; i++) {
            var item = list[i];
            $(select).append(
                "<option value='" + item.value + "'>" + item.name
                + "</option>");
        }
    },

    download: function (fileId) {
        fileId = encodeURIComponent(fileId);
        window.location.href = Common.ctxPath + "/core/file/get.do?id=" + fileId
    },

    /* 搜索 */
    doSearchForm: function (form, tableIns, page) {
        var attributeJson = Lib.getSearchParam("searchForm");
        var data = form.serializeJson();
        data.attributeJson = attributeJson;
        if (page != null) {
            tableIns.reload({
                where: data,
                page: {
                    curr: page
                }
            });
        } else {
            tableIns.reload({
                where: data
            });
        }

    },
    closeFrame: function () {
        var index = parent.layer.getFrameIndex(window.name); // 先得到当前iframe层的索引
        parent.layer.close(index); // 再执行关闭
    },

    submitForm: function (url, form, paras, callBack) {
        var formPara = form.serializeJson();
        for (var key in paras) {
            formPara[key] = paras[key];
        }
        Common.post(url, formPara, callBack);
    },
    buttonEnable: function (buttonCode, enable) {
        var btn = $("#table-button-" + buttonCode);
        if (enable) {
            btn.attr('disabled', "false");
            btn.removeClass("button-disabled")
        } else {
            btn.attr('disabled', "true");
            btn.addClass('button-disabled');
        }

    },
    getTableHeight: function (queryLine) {
        // 表格相对高度
        if (queryLine == 1) {
            return "full-180";
        } else if (queryLine == 2) {
            return "full-250"
        } else if (queryLine == 3) {
            return "full-350"
        } else {
            return "full"
        }
    }, imgUpdateSort: function (id, imgId, tag) {//id:绑定图片上传插件ID imgId:拖动元素父ID【用于多图上传时】
        $(".img_class").hover(function () {
            $(this).find(".opacityImg").show();
        }, function () {
            $(this).find(".opacityImg").hide();
        });
        //图片元素拖动
        var goodsImg = document.getElementById(imgId);
        new Sortable(goodsImg, {group: "omega"});
        // goodsImg.ondragover=function(ev){
        // 	ev.stopPropagation();
        // 	ev.preventDefault();
        // 	ev.dataTransfer = ev.originalEvent.dataTransfer;
        // }
        var upload = layui.upload;
        var files;//所有图片
        var imgSort = new Array();//定义图片排序数组
        var goodsL = "";
        var accept = 'images';
        var exts = null;
        if(tag == 'doc'){
            accept = 'file'; //默认所有文件都允许
            exts = 'docx|doc|png|jpg';
        }
        upload.render({
            elem: '#' + id
            , accept: accept//默认所有文件都允许
            ,exts:exts
            ,size:5120//图片大小限制
            , url: Common.ctxPath + "/jlw/file/update.do"
            , multiple: true
            , choose: function (obj) {
                files = this.files = obj.pushFile();
                var fileName = [];
                for (var key in files) {
                    fileName.push(files[key].name);
                }
                this.data = {'fileName': fileName};//传参
                goodsL = fileName.length;//上传商品的个数
                //this.url = Common.ctxPath + "/jlw/file/update.do?fileName="+fileName;//传参
                imgSort = new Array();//重置图片排序数组
            }
            , done: function (res) {//每成功一次调用
                if (res.code == 0) {
                    imgSort[res.data.sort] = {name: res.data.name, url: res.data.url,format:res.data.format};//相应地址存入数组
                    goodsL = goodsL - 1;
                } else {
                    Common.alert(res.msg);
                    goodsL = goodsL - 1;
                }

                if (goodsL == 0) {
                    var str = "";
                    for (var i = 0; i < imgSort.length; i++) {
                        if (imgSort[i] != "" || imgSort[i] != undefined || imgSort[i] != "undefined" | imgSort[i] != "[]" || imgSort[i] != null) {
                            str += "<div class=\"layui-upload-drag img_class\">\n" +
                                "        <div>\n" +
                                "            <img data-url='" + imgSort[i].url + "' data-name='" + imgSort[i].name + "'  src=\"" + (imgSort[i].format =='doc' ||imgSort[i].format =='docx'?Common.ctxPath +'/filesystem/temp/label/fileImg.jpg':Common.ctxPath + imgSort[i].url) + "\" style=\"height: 100%;\"/>\n" +
                                "        </div>\n" +
                                "        <div class=\"opacityImg\" style=\"background-color: #393D49;opacity:0.3;display: none;\"></div>\n" +
                                "        <span class=\"opacityImg\" style=\"position: relative;display: none;\">\n" +
                                "            <i class=\"layui-icon layui-icon-close-fill button-style-del\" onclick=\"img_del(this,'')\"></i>\n" +
                                (imgSort[i].format =='doc' ||imgSort[i].format =='docx'?(
                                "            <a href='"+Common.ctxPath + imgSort[i].url+"'><i class=\"layui-icon layui-icon-close-fill layui-icon-ok-circle\"></i></a>"):
                                ("            <i class=\"layui-icon layui-icon-close-fill layui-icon-ok-circle\" index=\"" + imgSort[i].url + "\" onclick=\"img_see(this)\"></i>\n"
                                )) + " </span>\n" +
                                (tag == 1 ? "<label name=\"linkUrl\" linkurl='#' data='{\"is_show_promote\":\"\",\"show_vip_ids\":\"\"}' class='colorGray' onclick=\"setUpAddress(this)\" style=\"position: absolute;top: 144px;left:100px;\">设置链接</label>" : "") +
                                "    </div>";
                        }
                    }
                    if (str[i] != "" || str != undefined || str != "undefined" | str != "[]" || str != null) {
                        $("#"+imgId).append(str);
                        $(".img_class").hover(function () {
                            $(this).find(".opacityImg").show();
                        }, function () {
                            $(this).find(".opacityImg").hide();
                        });
                    }
                    //删除队列中的文件
                    for (var key in files) {
                        delete files[key];
                    }
                }
            }
        });
    }, sendFile: function (files, key) {//summernote编辑框上传图片
        var files_length = files.length;
        //此处循环上传每一个图片
        for (var i = 0; i < files_length; i++) {
            var imageData = new FormData();
            imageData.append("imageData", files[i]);
            $.ajax({
                url: Common.ctxPath + '/jlw/file/update.do', // 图片上传url
                type: 'POST',
                data: imageData,
                async: false,
                cache: false,
                contentType: false,
                processData: false,
                dataType: 'json',     // 以json的形式接收返回的数据
                // 图片上传成功
                success: function ($result) {
                    var imgNode = document.createElement("img");
                    imgNode.src = Common.ctxPath + $result.data.url;
                    key.summernote('insertNode', imgNode);
                },
                // 图片上传失败
                error: function () {
                    console.log('图片上传失败');
                }
            });
        }
    }, refreshIndex: function (v) {//应用首页变化 v：1或者空表示PC端 v:2表示手机端
        layer.confirm('<span style="color: red;">最新的首页数据将会全部应用！</span><br/>是否确认？', function (index) {
            var url = '/jlw/page/refreshIndex.json';
            if(v == 2){
                url = "/jlw/microWeb/refreshIndex.json"
            }
            $.ajax({
                url: Common.ctxPath + url, // 刷新首页
                type: 'POST',
                async: false,
                cache: false,
                contentType: false,
                processData: false,
                dataType: 'json',     // 以json的形式接收返回的数据
                success: function (result) {
                    layer.msg(result.msg, {
                        offset: ['50%'],
                        icon: result.code == 0 ? 1 : 2,
                        time: 2000 //2秒关闭（如果不配置，默认是3秒）
                    });
                },
                error: function () {
                    layer.msg("连接失败！", {
                        offset: ['50%'],
                        icon: 2,
                        time: 2000 //2秒关闭（如果不配置，默认是3秒）
                    });
                }
            });
        });
    }, getLogistics: function (logisticsName) {//根据快递公司名称获取对应公司编号 logisticsName：公司名称
        //快递100 快递公司名称 与公司编码 键值对
        var logisticsInfo = {
            "邮政快递包裹": "youzhengguonei",
            "邮政标准快递": "youzhengbk",
            "顺丰速运": "shunfeng",
            "韵达快递": "yunda",
            "圆通速递": "yuantong",
            "中通快递": "zhongtong",
            "百世快递": "huitongkuaidi",
            "申通快递": "shentong",
            "京东物流": "jd",
            "天天快递": "tiantian",
            "德邦物流": "debangwuliu",
            "百世快运": "baishiwuliu",
            "韵达快运": "yundakuaiyun",
            "德邦快递": "debangkuaidi",
            "中通快运": "zhongtongkuaiyun",
            "苏宁物流": "suning"
        };
        var val = logisticsInfo[logisticsName];//根据键获取值
        return val;
    },openPopup:function (data) {//打开页面或弹窗
        $.ajax({
            url: Common.ctxPath + '/jlw/page/openPopup.do',
            type: 'get',
            data:data,
            dataType: 'json',     // 以json的形式接收返回的数据
            success: function (result) {

            }
        });
    },cancelAndCross:function (data) {//点击取消或X
        $.ajax({
            url: Common.ctxPath + '/jlw/page/cancelAndCross.do',
            type: 'get',
            data:data,
            dataType: 'json',     // 以json的形式接收返回的数据
            success: function (result) {

            }
        });
    },closeOrder:function (data) {//打开页面或关闭整个Order模块
        $.ajax({
            url: Common.ctxPath + '/jlw/page/closeOrder.do',
            type: 'get',
            data:data,
            dataType: 'json',     // 以json的形式接收返回的数据
            success: function (result) {

            }
        });
    },webSocketReturn:function (data) {//处理webSocket服务器发送消息
        if(data != ""){
            var d = data.replace(/=/g,":").split("&");
            var type = d[0] == "" || d[0] == undefined ?"":d[0].split(":")[1];
            var orderId = d[1] == "" || d[1] == undefined ?"":d[1].split(":")[1];
            var name = d[2] == "" || d[2] == undefined ?"":d[2].split(":")[1];
            return {type:type,orderId:orderId,name:name};
        }else {
            return "";
        }
    },logisticsDetails:function (id,signTime) {//根据快递号查看物流详情 id,logisticsName 快递名称,logisticsNum 快递号,signTime 签收时间
        if(!$.isEmpty(id)){
            $.ajax({
                url: Common.ctxPath + "/jlw/orderLogisticsInfo/getValues.json",type: "get",
                data: {id:id},
                dataType: 'json',
                success: function (rsp) {
                    if(rsp.code == 0){
                        var content = rsp.data[0].content;//快递
                        if(!$.isEmpty(content)){
                            var d = content.lastResult.data;
                            var h = "";
                            if(!$.isEmpty(signTime)){
                                h +='  <li class="layui-timeline-item">\n' +
                                    '    <i class="layui-icon layui-timeline-axis"></i>\n' +
                                    '    <div class="layui-timeline-content layui-text">\n' +
                                    '      <h3 class="layui-timeline-title">'+ signTime +'</h3>\n' +
                                    '      <p><span style="color:red;">已签收</span>，感谢您的购买！</p>' +
                                    '    </div>\n' +
                                    '  </li>\n';
                            }
                            for (var i = 0;i<d.length;i++){
                                h +='  <li class="layui-timeline-item">\n' +
                                    '    <i class="layui-icon layui-timeline-axis"></i>\n' +
                                    '    <div class="layui-timeline-content layui-text">\n' +
                                    '      <h3 class="layui-timeline-title">'+d[i].time+'</h3>\n' +
                                    '      <p>\n' + d[i].context + '</p>\n' +
                                    '    </div>\n' +
                                    '  </li>\n';
                            }
                            var htm = '<ul class="layui-timeline" style="overflow-y: auto;height: 660px;padding: 0 20px;">\n' + h + '</ul>';
                            layer.open({
                                type: 1,
                                offset: 'auto',
                                title:'物流信息',
                                shadeClose:'true',
                                area: ['800px', '720px'],
                                scrollbar:'false',
                                btnAlign: 'c',
                                content: htm, //这里content是一个普通的String
                            });
                        }else {
                            layer.msg('暂无物流信息！请联系管理员！',{icon:2});
                        }

                    }
                },error: function (rsp) {
                    layer.msg('网络连接失败！',{icon:2});
                }
            });
        }
    },packagingSelection:function (data,tag) { //商品选择包装 ,tag 1:表示从优惠券页面调用该方法  选择规格商品时不调用getOrderGoodsList.json方法获取数据
        packNum = 0;
        var notPackInfo = [];//无包装商品
        var isPackInfo = [];//有包装商品
        if(data != null && data.length > 0){
            for (var i = 0;i<data.length;i++){
                if(data[i].rankPriceType == 2 || data[i].showRankPriceType == 2){
                    data[i].buyPoints = data[i].buyBoxPointsNum;
                    data[i].rankPriceType = 2;
                }else {
                    data[i].buyPoints = data[i].buyPointsNum;
                    data[i].rankPriceType = 1;
                }
                if(data[i].packInfo != null){
                    isPackInfo.push(data[i]);
                }else {
                    notPackInfo.push(data[i]);
                }
            }
            if(isPackInfo.length == 0){
                layer.msg("选择成功！",{time:1000});
                orderGoodsList(notPackInfo);
            }else {
                f(isPackInfo,notPackInfo,tag);//调用循环选择包装对话框
            }
        }
    }, toLowerLine:function(str) {//驼峰式转下横线：
        var temp = str.replace(/[A-Z]/g, function (match) {
            return "_" + match.toLowerCase();
        });
        if (temp.slice(0, 1) === '_') { //如果首字母是大写，执行replace时会多一个_，这里需要去掉
            temp = temp.slice(1);
        }
        return temp;
    },toCamel:function (str) {//下横线转驼峰式：
        return str.replace(/([^_])(?:_+([^_]))/g, function ($0, $1, $2) {
            return $1 + $2.toUpperCase();
        });
    },photosScaling:function (){ //该方法用于layui photos相册的旋转与放缩
        var num = 0;
        $("#layui-layer-photos").append('<div class="icon" style="position:relative;width:100%;text-align:center;top:-62px;cursor:pointer;">' +
            '<img src="'+Common.ctxPath+'/filesystem/temp/label/xz_r.png" title="顺时针旋转" index="r" style="width:30px;height30px;">' +
            '<img src="'+Common.ctxPath+'/filesystem/temp/label/xz_n.png" title="初始图片" index="n" style="width:30px;height30px;">' +
            '<img src="'+Common.ctxPath+'/filesystem/temp/label/xz_l.png" title="逆时针旋转" index="l" style="width:30px;height30px;">' +
            '</div>');

        //旋转
        $(document).on("click", ".icon img", function(e) {
            if($(this).attr("index") == "r"){
                num = (num + 90) % 360;
            }else if($(this).attr("index") == "l"){
                num = (num - 90) % 360;
            }else {
                num = 0;
            }
            //$(".layui-layer.layui-layer-page.layui-layer-photos").css('transform', 'rotate(' + num + 'deg)');
            $(".layui-layer-phimg img").css('transform','rotate('+num+'deg)'); //此处只能旋转图片
        });
        //滚动放缩
        $(document).on("mousewheel DOMMouseScroll", ".layui-layer-phimg img", function(e) {
            var delta = (e.originalEvent.wheelDelta && (e.originalEvent.wheelDelta > 0 ? 1 : -1)) || // chrome & ie
                (e.originalEvent.detail && (e.originalEvent.detail > 0 ? -1 : 1)); // firefox
            var imagep = $(".layui-layer-phimg").parent().parent();
            var image = $(".layui-layer-phimg").parent();
            var h = image.height();
            var w = image.width();
            if (delta > 0) {
                h = h * 1.05;
                w = w * 1.05;
            } else if (delta < 0) {
                if (h > 100) {
                    h = h * 0.95;
                    w = w * 0.95;
                }
            }
            imagep.css("top", (window.innerHeight - h) / 2);
            imagep.css("left", (window.innerWidth - w) / 2);
            image.height(h);
            image.width(w);
            imagep.height(h);
            imagep.width(w);
        });
    },downLoadImg:function (element){ //将相应元素生成图片并下载  element:dom元素是要生成img的div容器
        var w = element.outerWidth();    // 设置该容器的宽
        var h = element.outerHeight();    // 设置该容器的高
        var canvas = document.createElement("canvas");
        canvas.width = w;    // 设置画布宽&&高
        canvas.height = h ;
        var offsetTop = element.offset().top;    // 获得该容器的上偏移量
        var offsetLeft = element.offset().left;    // 获得该容器的左偏移量
        var context = canvas.getContext("2d");
        context.translate(-offsetLeft, -offsetTop);
        //将滚动条滚动到最上面
        window.pageYoffset = 0;
        document.documentElement.scrollTop = 0;
        document.body.scrollTop = 0;
        var opts = {
            canvas: canvas,
            width: w,
            height: h,
            windowHeight: h, //获取Y方向滚动条内容
            background:"#FFFFFF",
            x: 0,
            y: h
        }
        return opts;
        // html2canvas(element, opts).then(function (canvas) {
        //     setTimeout(function(){
        //         layer.closeAll("loading");
        //         var a = document.createElementNS('http://www.w3.org/1999/xhtml', 'a');
        //         a.href = canvas.toDataURL('image/png',1.0);
        //         a.download = '统计图';
        //         a.click();
        //     },1000);
        // });
    }
    ,openPage:function (){ //打开相应链接+
        $.ajax({
            url: Common.ctxPath + '/jlw/marketingAPI/getAuthorizationCodeUrl.json',
            type: 'get',
            dataType: 'json',     // 以json的形式接收返回的数据
            success: function (result) {
                if(result.code == 0){
                    window.open (result.data,'新页面', 'height=500, width=600, top=0, right=0, toolbar=no, menubar=no,scrollbars=no, resizable=no,location=n o, status=no')
                }
            }
        });

    },
    /**
     * 打包下载相应地址的文件
     * @param userName 打包文件的名称
     * @param imgList 需要打包的文件路径
     */
    packageImages:function(userName,imgList) {
        layer.load();
        var zip = new JSZip();
        var cache = {};
        var promises = [];
        for (var i = 0; i < imgList.length; i++) {
            var name = i;
            var promise= Lib.getImgArrayBuffer(Common.ctxPath + imgList[i]).then(function (data){
                // 下载文件, 并存成ArrayBuffer对象(blob)
                var format = data.type.substring(data.type.lastIndexOf("/") + 1,data.type.length);
                if(format.indexOf("word") >= 0){ //因为word文件返回的不是其格式名称  所以作相应的处理
                    format = "doc";
                }
                name ++;
                zip.file(name + "." + format, data, { binary: true }); // 逐个添加文件
                cache[name + "." + format] = data;
            });
            promises.push(promise);
        }
        Promise.all(promises).then(function () {
            zip.generateAsync({ type: "blob" }).then(function (content) {
                // 生成二进制流
                saveAs(content, userName + '.zip'); // 利用file-saver保存文件  自定义文件名
                layer.closeAll("loading");
            });
        }).catch(function (res){
            layer.closeAll("loading");
            layer.msg('下载信息失败！',{icon:2});
        });
    },getImgArrayBuffer:function (url){
        return new Promise(function (resolve, reject) {
            //通过请求获取文件blob格式
            var xmlhttp = new XMLHttpRequest();
            xmlhttp.open("GET", url, true);
            xmlhttp.responseType = "blob";
            xmlhttp.onload = function () {
                if (this.status == 200) {
                    resolve(this.response);
                }else{
                    reject(this.status);
                }
            }
            xmlhttp.send();
        });
    },tableRefresh:function (index){ //模拟点击分页确定刷新数据  注：用于数据更新完成后数据刷新
        if(!$.isEmpty($(".layui-laypage-btn")[index || 0])){
            $(".layui-laypage-btn")[index || 0].click();//刷新table
        }else {
            $("#table-button-search").click();
        }
    }, nowTime_lab:function (s,id){// s:当前时间（格式：yyyy-MM-dd HH:mm:ss）  id:显示的位置
        var day = ['日','一','二','三','四','五','六'];
        var date = new Date(Date.parse(s.replace(/-/g,"/"))); //日期对象   注意【 '2015-05-04'是无法被各个浏览器中，使用new Date(str)来正确生成日期对象的。 正确的用法是'2015/05/05'.  】
        date.setSeconds(date.getSeconds()+1);
        var now = "";
        now = date.getFullYear()+"年"; //读英文就行了
        now = now + (date.getMonth()+1)+"月"; //取月的时候取的是当前月-1如果想取当前月+1就可以了
        now = now + date.getDate()+"日 ";
        now = now +" 星期"+day[date.getDay()];
        now = now + "  "+date.getHours()+"时";
        if(date.getMinutes() < 10){
            now = now + "0"+date.getMinutes()+"分";
        }else {
            now = now + date.getMinutes()+"分";
        }
        if(date.getSeconds() < 10){
            now = now + "0"+date.getSeconds() +"秒";
        }else {
            now = now + date.getSeconds() +"秒";
        }
        document.getElementById(id).innerHTML= now; //html是now这个字符串
        setTimeout("Lib.nowTime_lab(\'"+date+"\',\'"+id+"\')",1000); //设置过1000毫秒就是1秒，调用show方法
    },getNowTime:function (){
        var ret = Common.getAjax("/getNowTime.json");
        if(ret.code == 0){
            return ret.data;
        }else {
            return "";
        }
    },treeEach:function (dataInfo){ //处理tree数据(用户页面)
        var dataList = [];
        dataList.push({
            id:dataInfo.id,
            title:dataInfo.name,
            spread:true, //是否全部展开
            children:dataInfo.children,
            org:dataInfo.org
        });
        forMat(dataInfo.children,dataInfo.name);
        function forMat(childrenList,parentOrgName){
            $.each(childrenList,function(n,v) {
                childrenList[n].title = v.name;
                childrenList[n].spread = true; //是否全部展开
                childrenList[n].parentOrgName = parentOrgName;
                forMat(v.children,childrenList[n].name);
            });
        }
        return dataList;
    },treeEachAttr:function (dataInfo){ //处理tree数据(用户页面)
        var dataList = [];
        dataList.push({
            id:dataInfo.attributeId,
            title:dataInfo.attributeName,
            spread:true, //是否全部展开
            attributeSort:dataInfo.attributeSort,
            children:dataInfo.children
        });
        forMat(dataInfo.children,dataInfo.attributeName);
        function forMat(childrenList,parentOrgName){
            $.each(childrenList,function(n,v) {
                childrenList[n].id = v.attributeId;
                childrenList[n].title = v.attributeName;
                childrenList[n].spread = true; //是否全部展开
                childrenList[n].parentOrgName = parentOrgName;
                forMat(v.children,childrenList[n].name);
            });
        }
        return dataList;
    },getFormParam:function () { //获取表单页面参数【注：只能获取到通过模板生成的表单数据，原有数据需要自己获取】
        //输入方式(1单选 2多选 3输入 4多级联动  5上传图片 6上传附件 7多行输入 8日期)
        var attributeJson = [];
        $(".inputType1").each(function (){//遍历类型1（select）
            var attributeId = $(this).find("select").attr("attributeId"),
                val = $(this).find("select").val();
            attributeJson.push({attributeIds:attributeId,value:val});
        });
        $(".inputType2").each(function (){//遍历类型2（checkbox）
            var attributeId = $(this).find("input:eq(0)").attr("attributeId"),val = "",this_ = this;
            $(this_).find("input:checked").each(function (index,element){
                val += $(this).val();
                if(index < $(this_).find("input:checked").length - 1){
                    val += ",";
                }
            });
            attributeJson.push({attributeIds:attributeId,value:val});
        });
        $(".inputType3").each(function () {//遍历类型3（input）
            var attributeId = $(this).find("input").attr("attributeId"),
                val = $(this).find("input").val();
            attributeJson.push({attributeIds:attributeId,value:val});
        });
        $(".inputType4").each(function () {//遍历类型4（select联动）
            var attributeId = $(this).attr("attributeId"),val = "",this_ = this;
            $(this).find("select").each(function (index,element){
                if(!$.isEmpty($(this).val())){
                    var text = $(this).find("option:selected").text();
                    //val += $(this).val() + "|_|" + (text == "请选择"?"":text);
                    val += text == "请选择"?"":text;
                    if(index < $(this_).find("select").length - 1){
                        val += "|||";
                    }
                }
            });
            attributeJson.push({attributeIds:attributeId,value:val});
        });
        $(".inputType5").each(function () { //遍历类型5（img）
            var attributeId = $(this).attr("attributeId"),val = "",this_ = this;
            //图片路径(单品) rankPriceType ：1
            $("#"+$(this).attr("id")+" img").each(function(index,element){
                val += $(this).attr("data-url");
                if(index < $("#"+$(this_).attr("id")+" img").length - 1){
                    val += ",";
                }
            });
            attributeJson.push({attributeIds:attributeId,value:val});
        });
        $(".inputType6").each(function () {//遍历类型6（file+img）
            var attributeId = $(this).attr("attributeId"),val = "",this_ = this;
            //图片路径(单品) rankPriceType ：1
            $("#"+$(this).attr("id")+" img").each(function(index,element){
                val += $(this).attr("data-url");
                if(index < $("#"+$(this_).attr("id")+" img").length - 1){
                    val += ",";
                }
            });
            attributeJson.push({attributeIds:attributeId,value:val});
        });
        $(".inputType7").each(function () {//遍历类型7（textarea）
            var attributeId = $(this).find("textarea").attr("attributeId"),
                val = $(this).find("textarea").val();
            attributeJson.push({attributeIds:attributeId,value:val});
        });
        $(".inputType8").each(function () {//遍历类型8（input）
            var attributeId = $(this).find("input").attr("attributeId"),
                val = $(this).find("input").val();
            attributeJson.push({attributeIds:attributeId,value:val});
        });

        return attributeJson;
    },examine:function (examineInfoId,url,title) { //立即审核
        layer.open({
            type: 1,
            offset: 'auto',
            title:'审核',
            shadeClose:'true',
            area: ['500px', '320px'],
            scrollbar:'false',
            btnAlign: 'c',
            btn: ['确定', '取消'], //状态（1待审核 2已审核 3不通过）
            content: '<div class="layui-form examineInfo" style="padding: 20px;"><div class="layui-form-item">\n' +
                '    <label class="layui-form-label" style="width: 90px;">状态：</label>' +
                '    <div class="layui-input-block" style="margin-left: 140px;">' +
                '      <input type="radio" name="status" value="2" title="通过" checked>' +
                '      <input type="radio" name="status" value="3" title="不通过">' +
                '    </div>' +
                '  </div>' +
                '  <div class="layui-form-item layui-form-text">' +
                '    <label class="layui-form-label" style="width: 90px;">说明：</label>' +
                '    <div class="layui-input-block" style="margin-left: 140px;">' +
                '      <textarea name="examinRemark" placeholder="请输入审核说明" class="layui-textarea"></textarea>' +
                '    </div>' +
                '  </div></div>', //这里content是一个普通的String
            success: function (layero, index) {
                layui.form.render();
            }, yes: function (index) {
                var status = $(".examineInfo input[name='status']:checked").val();
                var examinRemark = $(".examineInfo textarea[name='examinRemark']").val();
                var ret = Common.postAjax("/jlw/examineInfo/examine.json",{status:status,examineInfoId:examineInfoId,examinRemark:examinRemark});
                layer.msg(ret.code == 0?"审核成功！":ret.msg, {
                    offset: ['50%'],
                    icon: ret.code == 0?1:2,
                    time: 2000 //2秒关闭（如果不配置，默认是3秒）
                },function (){
                    if(ret.code == 0){
                        layer.close(index);
                        if(!$.isEmpty(url)){
                            Lib.closeFrame();
                            parent.Common.openDlg(url,title);
                            parent.Lib.tableRefresh();
                        }else {
                            Lib.tableRefresh();
                            Lib.closeFrame();
                        }
                    }
                });
            }
        });
    },stateMatching:function (state){ //状态(1待审核 2审核中 3已公示 4已匹配)
        return state == 0?"未提交审核":
        state == 1?"待审核":
            state == 2?"审核中":
                state == 3?"已公示":
                    state == 34?"已公示 匹配中":
                        state == 4?"已匹配":'-';
    },matchStatusText:function (state){ //匹配状态 1审批中 2已取消 3未完结 4已完结 5不通过
        return state == 1?"<span style='color: #00B83F;'>审批中</span>":
            state == 2?"<span style='color: #d2d2d2;'>已取消</span>":
            state == 3?"<span style='color: #FFB800;'>未完结</span>":
            state == 4?"<span style='color: #1E9FFF;'>已完结</span>":
            state == 5?"<span style='color: #FF5722;'>不通过</span>":'-';
    },orderStatusText:function (state){ //订单状态 1执行中 2已完成 3撤销中 4已撤销 5不通过
        return state == 1?"<span style='color: #00B83F;'>执行中</span>":
            state == 2?"<span style='color: #1E9FFF;'>已完成</span>":
            state == 3?"<span style='color: #FFB800;'>撤销中</span>":
            state == 4?"<span style='color: #d2d2d2;'>已撤销</span>":
            state == 5?"<span style='color: #FF5722;'>不通过</span>":'-';
    },photosPublic:function (enclosures){//传入地址显示相册
        var list = [];
        if(!$.isEmpty(enclosures)){
            var array = enclosures.split(",");
            var num = 0;
            for (var i = 0;i<array.length;i++){
                if(!$.isEmpty(array[i])){
                    num++;
                }
            }
            for (var i = 0;i<array.length;i++){
                if(!$.isEmpty(array[i])){
                    list.push({
                        "alt": "共"+num+"张图",
                        "pid": i, //图片id
                        "src": Common.ctxPath + array[i], //原图地址
                        "thumb": Common.ctxPath + array[i] //缩略图地址
                    });
                }
            }
        }
        var json = {
            "title": "", //相册标题
            "id": 123, //相册id
            "start": 0, //初始显示的图片序号，默认0
            "data": list
        };
        layer.photos({
            photos: json
            ,anim: 5 //0-6的选择，指定弹出图片动画类型，默认随机（请注意，3.0之前的版本用shift参数）
        });
    },getSearchParam:function (id) { //获取搜索框的搜索条件（属性生成的）
        //输入方式(1：input 2:下拉)
        var attributeJson = [];
        $("#" +id+" .inputType1").each(function (){
            var p = {};
            var name = $(this).attr("attributeId");
            var v = $(this).find("input[name='"+name+"']").val();
            p[name] = v;
            attributeJson.push({
                attributeIds:name,
                value:v
            });
        });
        $("#" +id+" .inputType2").each(function (){//遍历类型2（checkbox）
            var p = {};
            var name = $(this).attr("attributeId");
            var v = $(this).find("select[name='"+name+"']").val();
            p[name] = v;
            attributeJson.push({
                attributeIds:name,
                value:v
            });
        });
        return JSON.stringify(attributeJson);
    },removeLocalStorage:function (key){
        Object.keys(localStorage).forEach(item => item.indexOf(key) != -1 ? localStorage.removeItem(item) : '')
    },openPapersInfo:function (papersInfo){//查看证书配置 papersInfo：证书配置信息 逗号隔开
        var sty = "padding: 5px 10px;width: 180px;float: left;border: 1px solid #a5b6c8;margin: 0 10px 10px 0;background:#eef3f7;border-radius:5px;";
        var htm = '<div class="layui-form" style="padding: 20px;" id="pzInfo">' +
            '                    <div name="pz" title="毕业证" style="'+sty+'">毕业证</div>' +
            '                    <div name="pz" title="资格证" style="'+sty+'">资格证</div>' +
            '                    <div name="pz" title="注册证" style="'+sty+'">注册证</div>' +
            '                    <div name="pz" title="身份证" style="'+sty+'">身份证</div>' +
            '                    <div name="pz" title="职称证" style="'+sty+'">职称证</div>' +
            '                    <div name="pz" title="安全员A证" style="'+sty+'">安全员A证</div>' +
            '                    <div name="pz" title="安全员B证" style="'+sty+'">安全员B证</div>' +
            '                    <div name="pz" title="安全员C证" style="'+sty+'">安全员C证</div>' +
            '                    <div name="pz" title="红头文件" style="'+sty+'">红头文件</div>' +
            '                    <div name="pz" title="评审表" style="'+sty+'">评审表</div>' +
            '                    <div name="pz" title="照片" style="'+sty+'">照片</div>' +
            '                    <div name="pz" title="印章" style="'+sty+'">印章</div>' +
            '                    <div name="pz" title="造价资格证" style="'+sty+'">造价资格证</div>' +
            '                    <div name="pz" title="监理资格证" style="'+sty+'">监理资格证</div>' +
            '                    <div name="pz" title="安全教育登记证" style="'+sty+'">安全教育登记证</div>' +
            '                    <div name="pz" title="职业资格证考试登记表" style="'+sty+'">职业资格证考试登记表</div>' +
            '                    <div name="pz" title="继续教育登记证书" style="'+sty+'">继续教育登记证书</div>' +
            '                    <div name="pz" title="岗位证书" style="'+sty+'">岗位证书</div>' +
            '                    <div name="pz" title="增项证" style="'+sty+'">增项证</div>' +
            '                    <div name="pz" title="离职证明" style="'+sty+'">离职证明</div>' +
            '                    <div name="pz" title="诚信卡" style="'+sty+'">诚信卡</div>' +
            '                    <div name="pz" title="监理注册证" style="'+sty+'">监理注册证</div>' +
            '                    <div name="pz" title="造价注册证" style="'+sty+'">造价注册证</div>' +
            '                    <div name="pz" title="造价其他" style="'+sty+'">造价其他</div></div>';
        layer.open({
            type: 1,
            offset: 'auto',
            title:'证书证件配置',
            shadeClose:'true',
            area: ['700px', '430px'],
            scrollbar:'false',
            btnAlign: 'c',
            content: htm, //这里content是一个普通的String
            success: function (layero, index) {
                if(!$.isEmpty(papersInfo)){
                    var papersInfoList = papersInfo.split(",");
                    for(var i = 0;i < papersInfoList.length;i++){
                        $("#pzInfo div[name='pz'][title='"+papersInfoList[i]+"']").css("background","red").css("border-color","red").css("color","white");
                    }
                    layui.form.render();
                }
            }, yes: function (index) {
                layer.close(index);
            }
        });
    }
};

//循环选择包装
var packNum = 0;//用于做当前商品选择包装位置  计数
function f(data,n,tag) {
    sessionStorage.setItem("packagingSelection",JSON.stringify(data[packNum]));//将传入的数据数组一条一条的存入缓存中 用于选择包装页面一个商品一个商品的选择包装
    var btn = ['下一个', '取消'];
     if((data.length - 1) == packNum){
        btn = ['上一个','确定','取消'];
        if(data.length == 1){
            btn = ['确定','取消'];
        }
    }else if(packNum != 0){
         btn = ['上一个','下一个','取消'];
    }
    layer.open({
        type: 2,
        offset: 'auto',
        title:'选择包装',
        shadeClose:'true',
        area: ['850px', '510px'],
        scrollbar:'false',
        id:"packagingSelection",
        btnAlign: 'c',
        content: Common.ctxPath + "/jlw/order/packagingSelection.do", //这里content是一个普通的String
        btn: btn,
        yes: function (index, layero) {
            if(packNum == 0){//下一个
                var packId = $("#packagingSelection iframe:eq(0)").contents().find(".on").attr("packId");
                var packName = $("#packagingSelection iframe:eq(0)").contents().find(".on").attr("packName");
                if(packId == null || packId == undefined || packId == ''){
                    Common.info("请选择包装");
                    return;
                }
                var rankPriceType = $("#packagingSelection iframe:eq(0)").contents().find(".on").attr("rankPriceType");
                data[packNum].packId = packId;
                data[packNum].packName = packName;
                data[packNum].rankPriceType = rankPriceType  || 1;
                if(tag == 1) {
                    data[packNum].realPrice = $("#packagingSelection iframe:eq(0)").contents().find(".on").attr("realprice");
                }
                if((data.length - 1) == packNum){//最后一个时提交
                    if(n.length >0){
                        orderGoodsList(n);
                    }
                    if(tag == 1){
                        orderGoodsList(data);
                        layer.msg("选择成功！",{time:1000});
                        layer.close(index);
                    }else {
                        var dataInfo ={
                            orderGoodsJson:JSON.stringify(data),
                            memberId:getMemberId()
                        }
                        var ret = Common.getAjax("/jlw/orderGoods/getOrderGoodsList.json",dataInfo);
                        if(ret.code == 0){
                            orderGoodsList(ret.data);
                            layer.msg("选择成功！",{time:1000});
                            layer.close(index);
                        }else {
                            Common.info(ret.msg);
                        }
                    }
                }else {
                    packNum ++;
                    layer.close(index);
                    setTimeout(function () {
                        f(data,n,tag);
                    },200);
                }
            }else {//上一个
                packNum --;
                layer.close(index);
                setTimeout(function () {
                    f(data,n,tag);
                },200);
            }
            //orderGoodsList(data);//订单详情页重加载
        },
        btn2: function (index, layero) {
            if(packNum == 0 && data.length != 1){//关闭
                layer.close(index);
            }else {//下一个
                var packId = $("#packagingSelection iframe:eq(0)").contents().find(".on").attr("packId");
                var packName = $("#packagingSelection iframe:eq(0)").contents().find(".on").attr("packName");
                if(packId == null || packId == undefined || packId == ''){
                    Common.info("请选择包装");
                    return;
                }
                var rankPriceType = $("#packagingSelection iframe:eq(0)").contents().find(".on").attr("rankPriceType");
                data[packNum].packId = packId;
                data[packNum].packName = packName;
                data[packNum].rankPriceType = rankPriceType || 1;
                if((data.length - 1) == packNum){//最后一个时提交
                    if(n.length >0){
                        orderGoodsList(n);
                    }
                    if(tag == 1){
                        orderGoodsList(data);
                        layer.msg("选择成功！",{time:1000});
                        layer.close(index);
                    }else {
                        var dataInfo ={
                            orderGoodsJson:JSON.stringify(data),
                            memberId:getMemberId()
                        }
                        var ret = Common.getAjax("/jlw/orderGoods/getOrderGoodsList.json",dataInfo);
                        if(ret.code == 0){
                            orderGoodsList(ret.data);
                            layer.close(index);
                            layer.msg("选择成功！",{time:1000});
                        }else {
                            Common.info(ret.msg);
                        }
                    }

                }else {
                    packNum ++;
                    layer.close(index);
                    setTimeout(function () {
                        f(data,n,tag);
                    },200);
                }
            }
        },
        btn3: function (index, layero) {
            layer.close(index);
        }
    });
}

//用于删除图片
function img_del(key, id) {
    layer.confirm('是否确定删除该图片？', function (index) {
        if ($.isEmpty(id)) {
            $(key).parent().parent().remove();
            layer.close(layer.index);
        } else {
            $.ajax({
                url: Common.ctxPath + '/jlw/goodsImg/delete.json',
                type: "POST",
                data: {ids: id},
                success: function (r, textStatus) {
                    if (r.msg == '成功') {
                        $(key).parent().parent().remove();
                    }
                    layer.close(layer.index);
                },
                error: function (r) {
                    layer.msg('网络连接失败！', {
                        icon: 2,
                        time: 2000 //2秒关闭（如果不配置，默认是3秒）
                    });
                }
            });
        }
    });
}

//用于查看图片
function img_see(key) {
    //示范一个公告层
    layer.open({
        type: 1
        , title: false //不显示标题栏
        , closeBtn: false
        , area: '500px;'
        , shadeClose: true
        , shade: 0.8
        , id: 'LAY_layuipro' //设定一个id，防止重复弹出
        , btnAlign: 'c'
        , moveType: 1 //拖拽模式，0或者1
        , content: '<img src="' + Common.ctxPath + $(key).attr("index") + '" style="width: 100%;height: 100%;"/>'
    });
}
